#include <jlog/jlog.hpp>
#include <string>

inline void SetConsoleTextColor(WORD color) {
        SetConsoleTextAttribute(GetStdHandle(STD_OUTPUT_HANDLE), color);
}

namespace jlog
{
    void log(const std::vector<token> tokens) {
        for (const token& t : tokens) {
            if (!t.delimiter.empty()) {
                SetConsoleTextColor(t.colorCode.nt_code);
                log_to_console(std::string(1, t.delimiter[0]) + t.content + std::string(1, t.delimiter[1]) + " ");
                log_to_file(std::string(1, t.delimiter[0]) + t.content + std::string(1, t.delimiter[1]) + " ");
            } else {
                SetConsoleTextColor(t.colorCode.nt_code);
                log_to_console(t.content + " ");
                log_to_file(t.content + " ");
            }
        }
        SetConsoleTextColor(color_codes::FG_DEFAULT.nt_code);
        log_to_console("\n");
        log_to_file("\n");
    }
}
